<?php

namespace Modules\Cotacao\Modules\Pedido\Services;

use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO;
use Util\SupUtilities;
use \Teknisa\Libs\Util\Utilities as LibUtilities;
use Teknisa\Libs\Util\XLS\FileLoader;
use Teknisa\Libs\Util\XLS\Table;
use PHPExcel_Cell;
use PhpOffice\PhpSpreadsheet\Cell\Coordinate;


class Sup09600IImportacaodeRFPService extends \Teknisa\GER\Controllers\TeknisaCrud
{
    protected $entityManager;
    protected $environment;
    protected $connection;
    protected $utilities;
    protected $newCode;
    protected $result;


    private $cellD3; //Validade Inicial
    private $cellD4; //Validade Final

    private $cellM2; //Responsavel Nome
    private $cellB6; //Codigo comprador valor

    private $cellE3; //Regiao 1
    private $cellE4; //Regiao 2
    private $cellE5; //Regiao 3
    private $cellE6; //Regiao 4
    private $cellF3; //Regiao 5
    private $cellF4; //Regiao 6
    private $cellF5; //Regiao 7
    private $cellF6; //Regiao 8
    private $cellO3; //Regiao 9
    private $cellO4; //Regiao 10
    private $cellO5; //Regiao 11
    private $cellO6; //Regiao 12
    private $cellP3; //Regiao 13
    private $cellP4; //Regiao 14
    private $cellP5; //Regiao 15
    private $cellP6; //Regiao 16
    private $cellQ3; //Regiao 17
    private $cellQ4; //Regiao 18
    private $cellQ5; //Regiao 19
    private $cellQ6; //Regiao 20

    private $cellD8; //CNPJ 1 valor
    private $cellG8; //CNPJ 2 valor
    private $cellJ8; //CNPJ 3 valor
    private $cellM8; //CNPJ 4 valor
    private $cellP8; //CNPJ 5 valor
    private $cellD9; //CNPJ 6 valor
    private $cellG9; //CNPJ 7 valor
    private $cellJ9; //CNPJ 8 valor
    private $cellM9; //CNPJ 9 valor
    private $cellP9; //CNPJ 10 valor

    private $cellH2; //UF Atendida 1
    private $cellH3; //UF Atendida 2
    private $cellH4; //UF Atendida 3
    private $cellH5; //UF Atendida 4
    private $cellH6; //UF Atendida 5
    private $cellI2; //UF Atendida 6
    private $cellI3; //UF Atendida 7
    private $cellI4; //UF Atendida 8
    private $cellI5; //UF Atendida 9
    private $cellI6; //UF Atendida 10

    private $cellJ3; //Exceção Região 1
    private $cellJ4; //Exceção Região 2
    private $cellJ5; //Exceção Região 3
    private $cellJ6; //Exceção Região 4

    private $inicial;
    private $final;
    private $comprador;

    public function __construct($crudService, $parameterBag, $entityManager, $environment, $connection, SupUtilities $supUtilities, LibUtilities $utilities, $newCode)

    {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->connection    = $connection;
        $this->supUtilities  = $supUtilities;
        $this->utilities = $utilities;
        $this->newCode    = $newCode;
        $this->crudService       = $crudService;
        $this->parameterBag =   $parameterBag;
        parent::__construct($crudService, $parameterBag);
    }

    public function execCheckImportProcedure($nrRFPMain)
    {
        try {
            $procedure = new StoredProcedure($this->connection, 'TEKNISA_RFP.CHECK_IMPORT');
            $procedure->addParam(new Param('NRRFPMAIN', Param::PARAM_INPUT, $nrRFPMain, Param::PARAM_TYPE_STR));
            $procedure->execute();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function execImportaRFPProcedure(array $lista)
    {
        try {
            $procedure = new StoredProcedure($this->connection, 'TEKNISA_RFP.IMPORTA_RFP');
            $procedure->addParam(new Param('NRRFPMAIN', Param::PARAM_INPUT, $lista['NRRFPMAIN'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('IDDISMONTLIS', Param::PARAM_INPUT, $lista['IDDISMONTLIS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('CDOPERINCL', Param::PARAM_INPUT, $this->environment->getCdoperador(), Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('MESSAGE', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 30));
            $procedure->addParam(new Param('ERROR', Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 4000));
            return $procedure->execute();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function limpaCPF_CNPJ($valor)
    {
        $valor = trim($valor);
        $valor = str_replace(".", "", $valor);
        $valor = str_replace(",", "", $valor);
        $valor = str_replace("-", "", $valor);
        $valor = str_replace("/", "", $valor);
        return $valor;
    }

    private function readFile($row)
    {
        try {
            $file = $row['FILE'];
            $sheetsToLoad = array('Sheasdasdsadet1', 'Sheet1', 'Planilha1');
            $xlsFile = FileLoader::loadFromBase64($file['content'], $file['name']);
            if (!$xlsFile) {
                throw new \Exception(self::IMPORT_LOAD_FILE_ERROR);
            }
            return $xlsFile->getActiveSheet();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function xlsReadInsert($row, $request)
    {
        try {
            $worksheet = $this->readFile($row);

            $file = $row['FILE'];
            $fileName = $file['name'];
            $this->result = $request;

            $nrRFPMain = $this->insertHeader($worksheet, $fileName);
            $table = $this->insertBody($worksheet, $nrRFPMain);

            return $table;
        } catch (Exception $e) {
            throw $e;
        }
    }

    private function insertBody($worksheet, $nrRFPMain)
    {
        $columnNames = ["CÓDIGO", "DESCRIÇÃO", "CÓDIGO", "NOME", "PREÇO", "CÓDIGO", "NOME", "PREÇO", "CÓDIGO", "NOME", "PREÇO", "CÓDIGO", "NOME", "PREÇO", "CÓDIGO", "NOME", "PREÇO"];
        $validaProduto = false;
        $codigo = null;
        $codigomarca1 = null;
        $nomemarca1 = null;
        $precomarca1 = null;
        $codigomarca2 = null;
        $nomemarca2 = null;
        $precomarca2 = null;
        $codigomarca3 = null;
        $nomemarca3 = null;
        $precomarca3 = null;
        $codigomarca4 = null;
        $nomemarca4 = null;
        $precomarca4 = null;
        $codigomarca5 = null;
        $nomemarca5 = null;
        $precomarca5 = null;

        $minRowIndex = 14;
        if (PHP_VERSION_ID >= 70400) {
            $maxColumnIndex = 17;            
        } else {
            $maxColumnIndex = 16;
        }
        $runDelete = true;

        try {
            $worksheetDimensions = $worksheet->getHighestRowAndColumn();
            $maxRowIndex = $worksheetDimensions['row'];

            $columnsReference  = self::buildColumnNameReference($worksheet, $maxColumnIndex, $columnNames);
            $tableRows = array();
            $worksheetContent = array();

            for ($row = $minRowIndex; $row <= $maxRowIndex; $row++) {
                $rowIsEmpty = true;

                for ($column = 0; $column <= $maxColumnIndex; $column++) {
                    if (PHP_VERSION_ID >= 70400) {
                        $columnLetterIndex = Coordinate::stringFromColumnIndex($column);
                    } else {
                        $columnLetterIndex = PHPExcel_Cell::stringFromColumnIndex($column);
                    }
                    $columnName = $columnsReference[$columnLetterIndex];
                    $cellValue = trim($worksheet->getCell($columnLetterIndex . $row)->getFormattedValue());

                    if (isset($cellValue) && !empty($cellValue)) {
                        if ($columnLetterIndex == "A") {
                            $rowIsEmpty = false;
                            $codigo = trim(str_replace(".", "", $cellValue));
                            $worksheetContent = array_merge($worksheetContent, array($columnName => $codigo));
                        } else if ($columnLetterIndex == "B") {
                            $descricao = $cellValue;
                            $worksheetContent = array_merge($worksheetContent, array($columnName => $descricao));
                        } else if ($columnLetterIndex == "C") {
                            $codigomarca1 = str_pad($cellValue, 5, '0', STR_PAD_LEFT);
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA1" => $codigomarca1));
                        } else if ($columnLetterIndex == "D") {
                            $nomemarca1 = $cellValue;
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA1" => $nomemarca1));
                        } else if ($columnLetterIndex == "E") {
                            $precomarca1 = trim(str_replace("R$", "", str_replace(',', '', $cellValue)));
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA1" => $precomarca1));
                        } else if ($columnLetterIndex == "F") {
                            $codigomarca2 = str_pad($cellValue, 5, '0', STR_PAD_LEFT);
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA2" => $codigomarca2));
                        } else if ($columnLetterIndex == "G") {
                            $nomemarca2 = $cellValue;
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA2" => $nomemarca2));
                        } else if ($columnLetterIndex == "H") {
                            $precomarca2 = trim(str_replace("R$", "", str_replace(',', '', $cellValue)));
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA2" => $precomarca2));
                        } else if ($columnLetterIndex == "I") {
                            $codigomarca3 = str_pad($cellValue, 5, '0', STR_PAD_LEFT);
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA3" => $codigomarca3));
                        } else if ($columnLetterIndex == "J") {
                            $nomemarca3 = $cellValue;
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA3" => $nomemarca3));
                        } else if ($columnLetterIndex == "K") {
                            $precomarca3 = trim(str_replace("R$", "", str_replace(',', '', $cellValue)));
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA3" => $precomarca3));
                        } else if ($columnLetterIndex == "L") {
                            $codigomarca4 = str_pad($cellValue, 5, '0', STR_PAD_LEFT);
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA4" => $codigomarca4));
                        } else if ($columnLetterIndex == "M") {
                            $nomemarca4 = $cellValue;
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA4" => $nomemarca4));
                        } else if ($columnLetterIndex == "N") {
                            $precomarca4 = trim(str_replace("R$", "", str_replace(',', '', $cellValue)));
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA4" => $precomarca4));
                        } else if ($columnLetterIndex == "O") {
                            $codigomarca5 = str_pad($cellValue, 5, '0', STR_PAD_LEFT);
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA5" => $codigomarca5));
                        } else if ($columnLetterIndex == "P") {
                            $nomemarca5 = $cellValue;
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA5" => $nomemarca5));
                        } else if ($columnLetterIndex == "Q") {
                            $precomarca5 = trim(str_replace("R$", "", str_replace(',', '', $cellValue)));
                            $worksheetContent = array_merge($worksheetContent, array($columnName . "_MARCA5" => $precomarca5));
                        }
                    }
                }

                if (!$rowIsEmpty) {
                    $params = [
                        "NRRFPMAIN" => intval($nrRFPMain),
                        "CODPRODUTO" => $codigo,
                        "CODMARCA1" => $codigomarca1,
                        "NMMARCA1" => $nomemarca1,
                        "VRPRECO1" => floatval($precomarca1),
                        "CODMARCA2" => $codigomarca2,
                        "NMMARCA2" => $nomemarca2,
                        "VRPRECO2" => floatval($precomarca2),
                        "CODMARCA3" => $codigomarca3,
                        "NMMARCA3" => $nomemarca3,
                        "VRPRECO3" => floatval($precomarca3),
                        "CODMARCA4" => $codigomarca4,
                        "NMMARCA4" => $nomemarca4,
                        "VRPRECO4" => floatval($precomarca4),
                        "CODMARCA5" => $codigomarca5,
                        "NMMARCA5" => $nomemarca5,
                        "VRPRECO5" => floatval($precomarca5)
                    ];

                    $worksheetRow = array(
                        'index' => $row,
                        'content' => $worksheetContent
                    );

                    if (isset($codigo)) {
                        $this->insertRFPPRODMARCA($params);
                        $runDelete = false;
                    }

                    array_push($tableRows, $worksheetRow);

                    $validaProduto = true;
                }

                $codigo = null;
                $codigomarca1 = null;
                $nomemarca1 = null;
                $precomarca1 = null;
                $codigomarca2 = null;
                $nomemarca2 = null;
                $precomarca2 = null;
                $codigomarca3 = null;
                $nomemarca3 = null;
                $precomarca3 = null;
                $codigomarca4 = null;
                $nomemarca4 = null;
                $precomarca4 = null;
                $codigomarca5 = null;
                $nomemarca5 = null;
                $precomarca5 = null;
            }

            if ($runDelete) {
                $this->deleteRFPITEMCOTA($nrRFPMain);
                $this->deleteRFPFORNECEDOR($nrRFPMain);
                $this->deleteRFPREGIAO($nrRFPMain);
                $this->deleteRFPPRODMARCA($nrRFPMain);
                $this->deleteRFMAIN($nrRFPMain);
                throw new \Exception('PRODUCT_NOT_FOUND');
            }

            $this->execCheckImportProcedure($nrRFPMain);

            $table = new Table($columnsReference, $tableRows);
            $rowsFromTable = $table->getRows();

            return $rowsFromTable;
        } catch (Exception $e) {
            throw $e;
        }
    }

    private function setCellValues($worksheet)
    {
        //Regiões
        $this->cellE3 = $worksheet->getCell('E3')->getValue(); //Regiao 1
        $this->cellE4 = $worksheet->getCell('E4')->getValue(); //Regiao 2
        $this->cellE5 = $worksheet->getCell('E5')->getValue(); //Regiao 3
        $this->cellE6 = $worksheet->getCell('E6')->getValue(); //Regiao 4
        $this->cellF3 = $worksheet->getCell('F3')->getValue(); //Regiao 5
        $this->cellF4 = $worksheet->getCell('F4')->getValue(); //Regiao 6
        $this->cellF5 = $worksheet->getCell('F5')->getValue(); //Regiao 7
        $this->cellF6 = $worksheet->getCell('F6')->getValue(); //Regiao 8
        $this->cellO3 = $worksheet->getCell('O3')->getValue(); //Regiao 9
        $this->cellO4 = $worksheet->getCell('O4')->getValue(); //Regiao 10
        $this->cellO5 = $worksheet->getCell('O5')->getValue(); //Regiao 11
        $this->cellO6 = $worksheet->getCell('O6')->getValue(); //Regiao 12
        $this->cellP3 = $worksheet->getCell('P3')->getValue(); //Regiao 13
        $this->cellP4 = $worksheet->getCell('P4')->getValue(); //Regiao 14
        $this->cellP5 = $worksheet->getCell('P5')->getValue(); //Regiao 15
        $this->cellP6 = $worksheet->getCell('P6')->getValue(); //Regiao 16
        $this->cellQ3 = $worksheet->getCell('Q3')->getValue(); //Regiao 17
        $this->cellQ4 = $worksheet->getCell('Q4')->getValue(); //Regiao 18
        $this->cellQ5 = $worksheet->getCell('Q5')->getValue(); //Regiao 19
        $this->cellQ6 = $worksheet->getCell('Q6')->getValue(); //Regiao 20

        //Validade
        $this->cellD3 = $worksheet->getCell('D3')->getValue(); //Validade Inicial
        $this->cellD4 = $worksheet->getCell('D4')->getValue(); //Validade Final

        if (!isset($this->cellD3) || !isset($this->cellD4)) {
            throw new \Exception("VALIDADE_NAO_INFORMADA");
        }

        //Comprador
        $this->cellB6 = $worksheet->getCell('B6')->getValue(); //Codigo comprador valor
        if (!isset($this->cellB6)) {
            throw new \Exception("COMPRADOR_NAO_INFORMADO");
        }


        $this->cellM2 = $worksheet->getCell('M2')->getValue(); //Responsavel Nome

        //Fornecedor
        $this->cellD8 = $worksheet->getCell('D8')->getValue(); //CNPJ 1 valor
        $this->cellG8 = $worksheet->getCell('G8')->getValue(); //CNPJ 2 valor
        $this->cellJ8 = $worksheet->getCell('J8')->getValue(); //CNPJ 3 valor
        $this->cellM8 = $worksheet->getCell('M8')->getValue(); //CNPJ 4 valor
        $this->cellP8 = $worksheet->getCell('P8')->getValue(); //CNPJ 5 valor
        $this->cellD9 = $worksheet->getCell('D9')->getValue(); //CNPJ 6 valor
        $this->cellG9 = $worksheet->getCell('G9')->getValue(); //CNPJ 7 valor
        $this->cellJ9 = $worksheet->getCell('J9')->getValue(); //CNPJ 8 valor
        $this->cellM9 = $worksheet->getCell('M9')->getValue(); //CNPJ 9 valor
        $this->cellP9 = $worksheet->getCell('P9')->getValue(); //CNPJ 10 valor

        //UF
        $this->cellH2 = $worksheet->getCell('H2')->getValue(); //UF Atendida 1
        $this->cellH3 = $worksheet->getCell('H3')->getValue(); //UF Atendida 2
        $this->cellH4 = $worksheet->getCell('H4')->getValue(); //UF Atendida 3
        $this->cellH5 = $worksheet->getCell('H5')->getValue(); //UF Atendida 4
        $this->cellH6 = $worksheet->getCell('H6')->getValue(); //UF Atendida 5
        $this->cellI2 = $worksheet->getCell('I2')->getValue(); //UF Atendida 6
        $this->cellI3 = $worksheet->getCell('I3')->getValue(); //UF Atendida 7
        $this->cellI4 = $worksheet->getCell('I4')->getValue(); //UF Atendida 8
        $this->cellI5 = $worksheet->getCell('I5')->getValue(); //UF Atendida 9
        $this->cellI6 = $worksheet->getCell('I6')->getValue(); //UF Atendida 10

        //Exceções região
        $this->cellJ3 = $worksheet->getCell('J3')->getValue(); //Exceção Região 1
        $this->cellJ4 = $worksheet->getCell('J4')->getValue(); //Exceção Região 2
        $this->cellJ5 = $worksheet->getCell('J5')->getValue(); //Exceção Região 3
        $this->cellJ6 = $worksheet->getCell('J6')->getValue(); //Exceção Região 4
    }

    private function checkComprador($comprador)
    {
        try {
            $sql = "SELECT NMOPERADOR, CDOPERADOR
                      FROM OPERADOR
                     WHERE CDOPERADOR = :CDOPERADOR";

            $stmt = $this->connection->prepare($sql);
            $stmt->execute(array(
                "CDOPERADOR" => $comprador
            ));

            $data = $stmt->fetchAll();
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        }

        if (isset($data) && count($data) === 0) {
            throw new \Exception("COMPRADOR_N_CADASTRADO");
        }
    }

    private function checkFornecedor($cnpjs, $request)
    {
        try {
            $this->dataSourceName = 'fornecedor';
            $filterCriteria = new FilterCriteria($this->dataSourceName);
            $filterCriteria->addCondition('NRINSJURFORN', $cnpjs);
            $newRequest = new Filter($filterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            $newResponse = new DTO\Response();

            parent::find($newRequest, $newResponse);
            $data = $newResponse->getDataSets();


            if (is_array($data) && count($data)) {
                $data = end($data);
                if ($data->getDataSourceName() === $this->dataSourceName) {
                    $newData = $data->getRows();
                }
            }
            if (!count($newData)) {
                throw new \Exception("FORNECEDOR_NOT_REGISTERED");
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function checkRegiao($regiao, $request)
    {
        try {
            $this->dataSourceName = 'regiao';
            $filterCriteria = new FilterCriteria($this->dataSourceName);
            $filterCriteria->addCondition('CDREGIAO', $regiao);
            $newRequest = new Filter($filterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            $newResponse = new DTO\Response();

            parent::find($newRequest, $newResponse);
            $data = $newResponse->getDataSets();


            if (is_array($data) && count($data)) {
                $data = end($data);
                if ($data->getDataSourceName() === $this->dataSourceName) {
                    $newData = $data->getRows();
                }
            }
            if (!count($newData)) {
                throw new \Exception("REGION_NOT_REGISTERED");
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function checkUnidadeFederativa($estado, $request)
    {
        try {
            $this->dataSourceName = 'estado';
            $filterCriteria = new FilterCriteria($this->dataSourceName);
            $filterCriteria->addCondition('SGESTADO', $estado);
            $newRequest = new Filter($filterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            $newResponse = new DTO\Response();

            parent::find($newRequest, $newResponse);
            $data = $newResponse->getDataSets();


            if (is_array($data) && count($data)) {
                $data = end($data);
                if ($data->getDataSourceName() === $this->dataSourceName) {
                    $newData = $data->getRows();
                }
            }
            if (!count($newData)) {
                throw new \Exception("UF_NOT_REGISTERED");
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function checkValidade($dataInicial, $dataFinal)
    {
        $partesDataInicial = explode("/", $dataInicial);
        $partesDataFinal = explode("/", $dataFinal);
        $anoInicial = $partesDataInicial[2];
        $anoFinal = $partesDataFinal[2];
        if ($anoInicial == '1900' || $anoFinal == '1900') {
            throw new \Exception("INVALID_VALIDITY");
        }
        $data1 = \DateTime::createFromFormat('d/m/Y', $dataInicial);
        $data2 = \DateTime::createFromFormat('d/m/Y', $dataFinal);
        if ($data1 > $data2) {
            throw new \Exception("VALIDITY_CHECK");
        }
    }


    private function insertHeader($worksheet, $fileName)
    {
        try {
            $this->setCellValues($worksheet);

            $this->inicial =  gmdate('d/m/Y', ((int)$this->cellD3 - 25569) * 86400);
            $this->final =  gmdate('d/m/Y', ((int)$this->cellD4 - 25569) * 86400);
            $this->comprador = isset($this->cellB6) ? str_pad($this->cellB6, 12, '0', STR_PAD_LEFT) : null;

            $this->checkValidade($this->inicial, $this->final);

            $this->checkComprador($this->comprador);

            $params = [
                "COMPRADOR" => $this->comprador,
                "DTVALIDADEINICIAL" => $this->inicial,
                "DTVALIDADEFINAL" => $this->final,
                "STATUS" => 'PENDENTE',
                "DTIMPORTACAO" => date("d/m/Y"),
                "RESPONSAVEL" => $this->environment->getCdoperador(),
                "DSARQUIVO" => $fileName,
                "CDOPERLOGADO" => $this->environment->getCdoperador(),
                "CDFILIAL" => $this->environment->getCdFilial()
            ];

            if (in_array(null, $params, true)) {
                throw new \Exception("CHECK_SPREADSHEET");
            }

            $UFServed = [
                "0"  => $this->cellH2,
                "1"  => $this->cellH3,
                "2"  => $this->cellH4,
                "3"  => $this->cellH5,
                "4"  => $this->cellH6,
                "5"  => $this->cellI2,
                "6"  => $this->cellI3,
                "7"  => $this->cellI4,
                "8"  => $this->cellI5,
                "9"  => $this->cellI6
            ];

            $regions = [
                "0"  => $this->cellE3,
                "1"  => $this->cellE4,
                "2"  => $this->cellE5,
                "3"  => $this->cellE6,
                "4"  => $this->cellF3,
                "5"  => $this->cellF4,
                "6"  => $this->cellF5,
                "7"  => $this->cellF6,
                "8"  => $this->cellO3,
                "9"  => $this->cellO4,
                "10" => $this->cellO5,
                "11" => $this->cellO6,
                "12" => $this->cellP3,
                "13" => $this->cellP4,
                "14" => $this->cellP5,
                "15" => $this->cellP6,
                "16" => $this->cellQ3,
                "17" => $this->cellQ4,
                "18" => $this->cellQ5,
                "19" => $this->cellQ6
            ];

            $regionsException = [
                "0"  => $this->cellJ3,
                "1"  => $this->cellJ4,
                "2"  => $this->cellJ5,
                "3"  => $this->cellJ6
            ];

            $regionsLenght = count(array_filter($regions));
            $UFLenght = count(array_filter($UFServed));
            $regionsExceptionLenght = count(array_filter($regionsException));
            $contentLenght = 0;
            if ($regionsExceptionLenght && !$UFLenght) {
                throw new \Exception("SPREADSHEET_CONFLICT");
            }
            if ($regionsLenght == 0 && $UFLenght == 0) {
                throw new \Exception("REGION_OR_UF_NULL");
            }
            if ($regionsLenght && $regionsExceptionLenght) {
                foreach ($regions as $region) {
                    if ($region != null) {
                        if (in_array($region, $regionsException)) {
                            $contentLenght++;
                        }
                    }
                }
                if ($contentLenght > 0) {
                    throw new \Exception("REGION_EXCEPTION");
                }
            }

            $cnpjs = [
                "0" => isset($this->cellD8) ? $this->limpaCPF_CNPJ($this->cellD8) : null,
                "1" => isset($this->cellG8) ? $this->limpaCPF_CNPJ($this->cellG8) : null,
                "2" => isset($this->cellJ8) ? $this->limpaCPF_CNPJ($this->cellJ8) : null,
                "3" => isset($this->cellM8) ? $this->limpaCPF_CNPJ($this->cellM8) : null,
                "4" => isset($this->cellP8) ? $this->limpaCPF_CNPJ($this->cellP8) : null,
                "5" => isset($this->cellD9) ? $this->limpaCPF_CNPJ($this->cellD9) : null,
                "6" => isset($this->cellG9) ? $this->limpaCPF_CNPJ($this->cellG9) : null,
                "7" => isset($this->cellJ9) ? $this->limpaCPF_CNPJ($this->cellJ9) : null,
                "8" => isset($this->cellM9) ? $this->limpaCPF_CNPJ($this->cellM9) : null,
                "9" => isset($this->cellP9) ? $this->limpaCPF_CNPJ($this->cellP9) : null
            ];

            $cnpjLenght = count(array_filter($cnpjs));
            if (!$cnpjLenght) {
                throw new \Exception("FORNECEDOR_NAO_INFORMADO");
            }
            foreach ($cnpjs as $cnpj) {
                if ($cnpj != null) {
                    $this->checkFornecedor($cnpj, $this->result);
                }
            }
            foreach ($regions as $regiao) {
                if ($regiao != null) {
                    $this->checkRegiao($regiao, $this->result);
                }
            }
            foreach ($UFServed as $unidadeFederativa) {
                if ($unidadeFederativa != null) {
                    $this->checkUnidadeFederativa($unidadeFederativa, $this->result);
                }
            }


            $paramsSearchRFPMain = [
                "COMPRADOR" => $this->comprador,
                "DTVALIDADEINICIAL" => $this->inicial,
                "DTVALIDADEFINAL" => $this->final,
                "RESPONSAVEL" => $this->environment->getCdoperador(),
                "DSARQUIVO" => $fileName
            ];
            $nrRFPMain = $this->searchNRRFPMAIN($paramsSearchRFPMain);
            $statusData = $this->checkStatusRFP($nrRFPMain);
            if (isset($statusData) && count($statusData)) {
                if ($statusData[0]['STATUS'] === "GERADO") {
                    throw new \Exception("ADICIONADO_GERADO");
                } else {
                    $this->deleteRFPITEMCOTA($nrRFPMain);
                    $this->deleteRFPFORNECEDOR($nrRFPMain);
                    $this->deleteRFPREGIAO($nrRFPMain);
                    $this->deleteRFPPRODMARCA($nrRFPMain);
                    $this->deleteRFMAIN($nrRFPMain);
                }
            }

            $nrRFPMain = $this->insertRFPMAIN($params);

            if ($UFLenght && $regionsLenght) {
                $UFRegions = $this->selectFederativeUnit(implode("_", $UFServed), implode("_", $regionsException));
                $unitRegion = [];
                foreach ($UFRegions as $federativeUnit) {
                    array_push($unitRegion, $federativeUnit['CDREGIAO']);
                }
                $arrayUnit = array_merge($regions, $unitRegion);
                $unitFormated = array_unique(array_map(function ($row) {
                    return $row;
                }, $arrayUnit));
                foreach ($unitFormated as $regiao) {
                    if ($regiao != null) {
                        $this->insertRFPREGIAO($regiao, $nrRFPMain);
                    }
                }
            } else if ($UFLenght) {
                $UFRegions = $this->selectFederativeUnit(implode("_", $UFServed), implode("_", $regionsException));

                foreach ($UFRegions as $UFRegion) {
                    $this->insertRFPREGIAO($UFRegion['CDREGIAO'], $nrRFPMain);
                }
            } else if ($regionsLenght) {
                foreach ($regions as $region) {
                    if (isset($region) && !empty($region)) {
                        $this->insertRFPREGIAO($region, $nrRFPMain);
                    }
                }
            }

            if ($cnpjLenght) {
                foreach ($cnpjs as $cnpj) {
                    if (isset($cnpj) && !empty($cnpj)) {
                        $this->insertRFPFORNECEDOR($cnpj, $nrRFPMain);
                    }
                }
            }

            return $nrRFPMain;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    protected static function getColumnString($column)
    {
        if (gettype($column) == 'integer')
            if (PHP_VERSION_ID >= 70400) {
                return Coordinate::stringFromColumnIndex($column);
            } else {
                return PHPExcel_Cell::stringFromColumnIndex($column);
            }
        else
            return $column;
    }

    private function buildColumnNameReference($worksheet, $maxColumn, $columnNames)
    {
        $reference = array();
        for ($column = 0; $column <= $maxColumn; $column++) {
            $columnString = self::getColumnString($column);
            $columnName = $worksheet->getCell($columnString . '13')->getValue();
            $reference[$columnString] = mb_strtoupper($columnName, 'UTF-8');
        }
        return ($reference);
    }

    private function getRFPMainNextValue()
    {
        try {
            $sql = "SELECT SEQ_RFPMAIN_NRRFPMAIN.NEXTVAL
                      FROM DUAL";
            $stmt = $this->connection->prepare($sql);
            $stmt->execute();
            $data = $stmt->fetchAll();

            if (isset($data) && count($data)) {
                return $data[0]['NEXTVAL'];
            }

            throw new \Exception('ERRO_RFPMAIN_INSERT');
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function insertRFPMAIN($row)
    {
        try {
            $nextValue = $this->getRFPMainNextValue();

            $sql = "INSERT INTO RFPMAIN (NRRFPMAIN,
                                         COMPRADOR,
                                         CDFILIAL,
                                         DTVALIDADEINICIAL,
                                         DTVALIDADEFINAL,
                                         STATUS,
                                         DTIMPORTACAO,
                                         RESPONSAVEL,
                                         DSARQUIVO,
                                         CDOPERLOGADO)
                                 VALUES (:NRRFPMAIN,
                                         :COMPRADOR,
                                         :CDFILIAL,
                                         :DTVALIDADEINICIAL,
                                         :DTVALIDADEFINAL,
                                         :STATUS,
                                         :DTIMPORTACAO,
                                         :RESPONSAVEL,
                                         :DSARQUIVO,
                                         :CDOPERLOGADO)";
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute(array(
                "NRRFPMAIN" => $nextValue,
                "COMPRADOR" => $row["COMPRADOR"],
                "CDFILIAL" => $row["CDFILIAL"],
                "DTVALIDADEINICIAL" => $row["DTVALIDADEINICIAL"],
                "DTVALIDADEFINAL" => $row["DTVALIDADEFINAL"],
                "STATUS" => $row['STATUS'],
                "DTIMPORTACAO" => $row["DTIMPORTACAO"],
                "RESPONSAVEL" => $row["RESPONSAVEL"],
                "DSARQUIVO" => $row["DSARQUIVO"],
                "CDOPERLOGADO" => $row["CDOPERLOGADO"]
            ));
            return $nextValue;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function insertRFPPRODMARCA($row)
    {
        try {
            $sql = "INSERT INTO RFPPRODMARCA (NRRFPPRODMARCA,
                                              NRRFPMAIN,
                                              CODPRODUTO,
                                              CODMARCA1,
                                              VRPRECO1,
                                              CODMARCA2,
                                              VRPRECO2,
                                              CODMARCA3,
                                              VRPRECO3,
                                              CODMARCA4,
                                              VRPRECO4,
                                              CODMARCA5,
                                              VRPRECO5) 
                                      VALUES (SEQ_RFPPRODMARCA_NRRFPPRDMARCA.NEXTVAL,
                                              :NRRFPMAIN,
                                              :CODPRODUTO,
                                              :CODMARCA1,
                                              :VRPRECO1,
                                              :CODMARCA2,
                                              :VRPRECO2,
                                              :CODMARCA3,
                                              :VRPRECO3,
                                              :CODMARCA4,
                                              :VRPRECO4,
                                              :CODMARCA5,
                                              :VRPRECO5)";
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute(array(
                "NRRFPMAIN" => $row["NRRFPMAIN"],
                "CODPRODUTO" => $row["CODPRODUTO"],
                "CODMARCA1" => $row["CODMARCA1"],
                "VRPRECO1" => $row["VRPRECO1"],
                "CODMARCA2" => $row["CODMARCA2"],
                "VRPRECO2" => $row["VRPRECO2"],
                "CODMARCA3" => $row["CODMARCA3"],
                "VRPRECO3" => $row["VRPRECO3"],
                "CODMARCA4" => $row["CODMARCA4"],
                "VRPRECO4" => $row["VRPRECO4"],
                "CODMARCA5" => $row["CODMARCA5"],
                "VRPRECO5" => $row["VRPRECO5"]
            ));
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function insertRFPREGIAO($row, $row2)
    {
        try {
            $sql = "INSERT INTO RFPREGIAO (
                                NRRFPREGIAO,
                                CODREGIAO,
                                NRRFPMAIN) 
                        VALUES (SEQ_RFPREGIAO_NRRFPREGIAO.NEXTVAL,
                                :CODREGIAO,
                                :NRRFPMAIN)";
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute(array(
                "CODREGIAO" => $row,
                "NRRFPMAIN" => $row2
            ));
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function insertRFPFORNECEDOR($row, $row2)
    {
        try {
            $sql = "INSERT INTO RFPFORNECEDOR (
                                NRRFPFORNECEDOR,
                                NRINSJURFRFP,
                                NRRFPMAIN) 
                        VALUES (SEQ_RFPFORNECEDOR_NRRFPFORN.NEXTVAL,
                                :NRINSJURFRFP,
                                :NRRFPMAIN)";
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute(array(
                "NRINSJURFRFP" => $row,
                "NRRFPMAIN" => $row2
            ));
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function searchNRRFPMAIN($row)
    {
        try {
            $sql = "SELECT NRRFPMAIN
                      FROM RFPMAIN
                     WHERE RESPONSAVEL = :RESPONSAVEL
                       AND DTVALIDADEINICIAL = :DTVALIDADEINICIAL
                       AND DTVALIDADEFINAL = :DTVALIDADEFINAL
                       AND COMPRADOR = :COMPRADOR
                       AND DSARQUIVO = :DSARQUIVO";

            $stmt = $this->connection->prepare($sql);
            $stmt->execute(array(
                "COMPRADOR" => $row["COMPRADOR"],
                "DTVALIDADEINICIAL" => $row["DTVALIDADEINICIAL"],
                "DTVALIDADEFINAL" => $row["DTVALIDADEFINAL"],
                "RESPONSAVEL" => $row["RESPONSAVEL"],
                "DSARQUIVO" => $row["DSARQUIVO"]
            ));
            $data = $stmt->fetchAll();

            if (isset($data) && count($data)) {
                return $data[0]['NRRFPMAIN'];
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function checkStatusRFP($nrRFPMain)
    {
        try {
            $sql = "SELECT STATUS
                      FROM RFPMAIN 
                     WHERE NRRFPMAIN = :NRRFPMAIN";

            $stmt = $this->connection->prepare($sql);
            $stmt->execute(array(
                "NRRFPMAIN" => $nrRFPMain
            ));
            return $stmt->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deleteRFMAIN($nrRFPMain)
    {
        try {
            $query = "DELETE FROM RFPMAIN RF WHERE RF.NRRFPMAIN = :NRRFPMAIN";
            $params = [
                "NRRFPMAIN"    => $nrRFPMain
            ];
            $this->supUtilities->crud($query, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function deleteRFPPRODMARCA($nrRFPMain)
    {
        try {
            $query = "DELETE FROM RFPPRODMARCA RFP WHERE RFP.NRRFPMAIN = :NRRFPMAIN";
            $params = [
                "NRRFPMAIN"    => $nrRFPMain
            ];
            $this->supUtilities->crud($query, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function deleteRFPREGIAO($nrRFPMain)
    {
        try {
            $query = "DELETE FROM RFPREGIAO RFPR WHERE RFPR.NRRFPMAIN = :NRRFPMAIN";
            $params = [
                "NRRFPMAIN"    => $nrRFPMain
            ];
            $this->supUtilities->crud($query, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function deleteRFPFORNECEDOR($nrRFPMain)
    {
        try {
            $query = "DELETE FROM RFPFORNECEDOR RFPF WHERE RFPF.NRRFPMAIN = :NRRFPMAIN";
            $params = [
                "NRRFPMAIN"    => $nrRFPMain
            ];
            $this->supUtilities->crud($query, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function deleteRFPITEMCOTA($nrRFPMain)
    {
        try {
            $query = "DELETE FROM RFPITEMCOTA RFPI WHERE RFPI.NRRFPMAIN = :NRRFPMAIN";
            $params = [
                "NRRFPMAIN" => $nrRFPMain
            ];
            $this->supUtilities->crud($query, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function selectFederativeUnit($uf, $exception)
    {
        try {
            $sql = "SELECT REGIAO.CDREGIAO
                      FROM REGIAO
                     WHERE REGIAO.CDPAIS = :P_CDPAIS
                       AND INSTR(:P_SGESTADO, REGIAO.SGESTADO) > 0
                       AND NOT EXISTS (SELECT 1
                                         FROM REGIAO R
                                        WHERE R.CDREGIAO = REGIAO.CDREGIAO
                                          AND INSTR(:P_EXCEPTION, R.CDREGIAO) > 0)";
            $params = array(
                "P_SGESTADO"  => $uf,
                "P_CDPAIS"    => '0055', //planilha não possiu campo de país
                "P_EXCEPTION" => $exception
            );
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}
